/* Tabela RECETPCARD: Receita por Tipo de Cardpio */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela RECETPCARD */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Receita por Tipo de Cardpio,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_PLA_RECETPCARD
AFTER DELETE OR INSERT OR UPDATE
ON RECETPCARD FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(500);
  V_DTOPER    DATE;
  V_CDARVPROD VARCHAR2(20);
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDARVPROD := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN
      V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || ' - ' || :OLD.CDFILAUXPRAT;
      V_DESC := V_DESC || 'Centr=' || :OLD.CDFILCENTPME;
      V_DESC := V_DESC || 'Tp.Ca=' || :OLD.CDTIPOCARD;
      SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
      V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
      IF (NVL(:OLD.CDAPRERECE, '') <> '') THEN
         V_DESC := V_DESC || ' Apres=' || :OLD.CDAPRERECE;
      END IF;
      V_DESC := V_DESC || ' Qtde=' || TRIM(TO_CHAR(ROUND(:OLD.QTPRODPRATTP, 5), '9999999990.00000'));
      IF (NVL(:OLD.SGUNIDADE, '') <> '') THEN
         V_DESC := V_DESC || ' Un=' || :OLD.SGUNIDADE;
      END IF;
      IF (NVL(:OLD.VRPEFATCOCPRTP, -1) <> -1) THEN
         V_DESC := V_DESC || ' GanhoCoc=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCOCPRTP, 5), '9999999990.00'));
      END IF;
      IF (NVL(:OLD.VRPEFATCORPRTP, -1) <> -1) THEN
         V_DESC := V_DESC || ' PerdLimp=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCORPRTP, 5), '9999999990.00'));
      END IF;
      IF (NVL(:OLD.HRTEMPPREPPRTP, '') <> '') THEN
         V_DESC := V_DESC || ' Temp=' || SUBSTR(:OLD.HRTEMPPREPPRTP, 1, 3) || ':' || SUBSTR(:OLD.HRTEMPPREPPRTP, 4, 5);
      END IF;
      IF (NVL(:OLD.QTBRUTAPRUNRTP, -1) <> -1) THEN
         V_DESC := V_DESC || ' QtBruta=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTAPRUNRTP, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:OLD.QTBRUTAPRTP, -1) <> -1) THEN
         V_DESC := V_DESC || ' QtReq=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTAPRTP, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:OLD.IDPRODBASEPRTP, '') <> '') THEN
         V_DESC := V_DESC || ' PrBase=' || :OLD.IDPRODBASEPRTP;
      END IF;
      IF (NVL(:OLD.VRPEFATNUTPRTP, -1) <> -1) THEN
         V_DESC := V_DESC || ' AprovNutr=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATNUTPRTP, 5), '9999999990.00'));
      END IF;
      IF (NVL(:OLD.QTCALCNUTRPRTP, -1) <> -1) THEN
         V_DESC := V_DESC || ' QtNutr=' || TRIM(TO_CHAR(ROUND(:OLD.QTCALCNUTRPRTP, 5), '9999999990.00000'));
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
      V_TIPO := '3';
      SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
      V_ITPESQ := :OLD.CDPRATO||:OLD.CDFILAUXPRAT||:OLD.CDFILCENTPME||:OLD.CDTIPOCARD||V_CDARVPROD;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDPRATO      <> :NEW.CDPRATO     ) OR
            (:OLD.CDPRODUTO    <> :NEW.CDPRODUTO   ) OR
            (:OLD.QTPRODPRATTP <> :NEW.QTPRODPRATTP) OR
            (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) OR
            (:OLD.CDFILCENTPME <> :NEW.CDFILCENTPME) OR
            (:OLD.CDTIPOCARD   <> :NEW.CDTIPOCARD  ) OR            
            (NVL(:OLD.CDAPRERECE,   '') <> NVL(:NEW.CDAPRERECE,   '')) OR
            (NVL(:OLD.SGUNIDADE,    '') <> NVL(:NEW.SGUNIDADE,    '')) OR
            (NVL(:OLD.VRPEFATCOCPRTP,  -1) <> NVL(:NEW.VRPEFATCOCPRTP,  -1)) OR
            (NVL(:OLD.VRPEFATCORPRTP,  -1) <> NVL(:NEW.VRPEFATCORPRTP,  -1)) OR
            (NVL(:OLD.HRTEMPPREPPRTP, '') <> NVL(:NEW.HRTEMPPREPPRTP, '')) OR
            (NVL(:OLD.QTBRUTAPRUNRTP,  -1) <> NVL(:NEW.QTBRUTAPRUNRTP,  -1)) OR
            (NVL(:OLD.QTBRUTAPRTP,     -1) <> NVL(:NEW.QTBRUTAPRTP,     -1)) OR
            (NVL(:OLD.IDPRODBASEPRTP, '') <> NVL(:NEW.IDPRODBASEPRTP, '')) OR
            (NVL(:OLD.VRPEFATNUTPRTP,  -1) <> NVL(:NEW.VRPEFATNUTPRTP,  -1)) OR
            (NVL(:OLD.QTCALCNUTRPRTP,  -1) <> NVL(:NEW.QTCALCNUTRPRTP,  -1)) THEN
            V_TIPO   := '2';
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
            V_ITPESQ := :OLD.CDPRATO||:OLD.CDFILAUXPRAT||:OLD.CDFILCENTPME||:OLD.CDTIPOCARD||V_CDARVPROD;
         END IF;
      ELSE
         V_TIPO   := '1';
         SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
         V_ITPESQ := :NEW.CDPRATO||:NEW.CDFILAUXPRAT||:NEW.CDFILCENTPME||:NEW.CDTIPOCARD||V_CDARVPROD;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDPRATO <> :NEW.CDPRATO) OR (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) THEN
            IF (:OLD.CDPRATO <> :NEW.CDPRATO) THEN
               V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || '|' || :NEW.CDPRATO || ' - ';
            ELSE
               V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || ' - ';
            END IF;
            IF (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) THEN
               V_DESC := V_DESC || :OLD.CDFILAUXPRAT || '|' || :NEW.CDFILAUXPRAT;
            ELSE
               V_DESC := V_DESC || :OLD.CDFILAUXPRAT;
            END IF; 
         ELSE
            V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || ' - ' || :OLD.CDFILAUXPRAT;
         END IF;
      ELSE
         V_DESC := V_DESC || 'Prato=' || :NEW.CDPRATO || ' - ' || :NEW.CDFILAUXPRAT;
      END IF; 
      IF UPDATING THEN
         IF (:OLD.CDFILCENTPME <> :NEW.CDFILCENTPME) THEN
            V_DESC := V_DESC || 'Centr=' || :OLD.CDFILCENTPME || '|' || :NEW.CDFILCENTPME;
         ELSE
            V_DESC := V_DESC || 'Centr=' || :OLD.CDFILCENTPME;
         END IF;
      ELSE
         V_DESC := V_DESC || 'Centr=' || :NEW.CDFILCENTPME;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDTIPOCARD <> :NEW.CDTIPOCARD) THEN
            V_DESC := V_DESC || 'Tp.Ca=' || :OLD.CDTIPOCARD || '|' || :NEW.CDTIPOCARD;
         ELSE
            V_DESC := V_DESC || 'Tp.Ca=' || :OLD.CDTIPOCARD;
         END IF;
      ELSE
         V_DESC := V_DESC || 'Tp.Ca=' || :NEW.CDTIPOCARD;
      END IF;      
      IF UPDATING THEN
         IF (:OLD.CDPRODUTO <> :NEW.CDPRODUTO) THEN
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
            V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
            V_DESC := V_DESC || '|' || V_CDARVPROD;
         ELSE
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
            V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
         END IF;
      ELSE
         SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
         V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
      END IF;
      IF (NVL(:NEW.CDAPRERECE, '') <> '') OR (UPDATING AND (NVL(:NEW.CDAPRERECE, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDAPRERECE, '') <> NVL(:NEW.CDAPRERECE, '')) THEN
               V_DESC := V_DESC || ' Apres=' || :OLD.CDAPRERECE || '|' || :NEW.CDAPRERECE;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Apres=' || :NEW.CDAPRERECE;
         END IF;
      END IF;
      IF UPDATING THEN
         IF (:OLD.QTPRODPRATTP <> :NEW.QTPRODPRATTP) THEN
            V_DESC := V_DESC || ' Qtde.=' || TRIM(TO_CHAR(ROUND(:OLD.QTPRODPRATTP, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTPRODPRATTP, 5), '9999999990.00000'));
         END IF;
      ELSE
         V_DESC := V_DESC || ' Qtde=' || TRIM(TO_CHAR(ROUND(:NEW.QTPRODPRATTP, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:NEW.SGUNIDADE, '') <> '') OR (UPDATING AND (NVL(:NEW.SGUNIDADE, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.SGUNIDADE, '') <> NVL(:NEW.SGUNIDADE, '')) THEN
               V_DESC := V_DESC || ' Un=' || :OLD.SGUNIDADE || '|' || :NEW.SGUNIDADE;
            END IF;
         ELSE 
            V_DESC := V_DESC || ' Un=' || :NEW.SGUNIDADE;
         END IF;
      END IF;
      IF (NVL(:NEW.VRPEFATCOCPRTP, -1) <> -1) OR (UPDATING AND (NVL(:NEW.VRPEFATCOCPRTP, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.VRPEFATCOCPRTP, -1) <> NVL(:NEW.VRPEFATCOCPRTP, -1)) THEN
               V_DESC := V_DESC || ' GanhoCoc=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCOCPRTP, 5), '9999999990.00')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCOCPRTP, 5), '9999999990.00'));
            END IF; 
         ELSE
            V_DESC := V_DESC || ' GanhoCoc=' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCOCPRTP, 5), '9999999990.00'));
         END IF;
      END IF;
      IF (NVL(:NEW.VRPEFATCORPRTP, -1) <> -1) OR (UPDATING AND (NVL(:NEW.VRPEFATCORPRTP, -1) = -1)) THEN
         IF UPDATING THEN
             IF (NVL(:OLD.VRPEFATCORPRTP, -1) <> NVL(:NEW.VRPEFATCORPRTP, -1)) THEN  
                V_DESC := V_DESC || ' PerdLimp=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCORPRTP, 5), '9999999990.00')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCORPRTP, 5), '9999999990.00'));
             END IF;
         ELSE
            V_DESC := V_DESC || ' PerdLimp=' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCORPRTP, 5), '9999999990.00'));
         END IF;
      END IF;
      IF (NVL(:NEW.HRTEMPPREPPRTP, '') <> '') OR (UPDATING AND (NVL(:NEW.HRTEMPPREPPRTP, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.HRTEMPPREPPRTP, '') <> NVL(:NEW.HRTEMPPREPPRTP, '')) THEN  
               IF (NVL(:OLD.HRTEMPPREPPRTP, '') = '') THEN
                  V_DESC := V_DESC || ' Temp=' || '|' || SUBSTR(:NEW.HRTEMPPREPPRTP, 1, 3) || ':' || SUBSTR(:NEW.HRTEMPPREPPRTP, 4, 5); 
               ELSE
                  V_DESC := V_DESC || ' Temp=' || SUBSTR(:OLD.HRTEMPPREPPRTP, 1, 3) || ':' || SUBSTR(:OLD.HRTEMPPREPPRTP, 4, 5) || '|' || SUBSTR(:NEW.HRTEMPPREPPRTP, 1, 3) || ':' || SUBSTR(:NEW.HRTEMPPREPPRTP, 4, 5);
               END IF;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Temp=' || SUBSTR(:NEW.HRTEMPPREPPRTP, 1, 3) || ':' || SUBSTR(:NEW.HRTEMPPREPPRTP, 4, 5);
         END IF;
      END IF;
      IF (NVL(:NEW.QTBRUTAPRUNRTP, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTBRUTAPRUNRTP, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTBRUTAPRUNRTP, -1) <> NVL(:NEW.QTBRUTAPRUNRTP, -1)) THEN  
               V_DESC := V_DESC || ' QtBruta=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTAPRUNRTP, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTAPRUNRTP, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' QtBruta=' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTAPRUNRTP, 5), '9999999990.00000'));
         END IF;
      END IF;
      IF (NVL(:NEW.QTBRUTAPRTP, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTBRUTAPRTP, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTBRUTAPRTP, -1) <> NVL(:NEW.QTBRUTAPRTP, -1)) THEN  
               V_DESC := V_DESC || ' QtReq=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTAPRTP, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTAPRTP, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' QtReq=' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTAPRTP, 5), '9999999990.00000'));
         END IF;
      END IF;
      IF (NVL(:NEW.IDPRODBASEPRTP, '') <> '') OR (UPDATING AND (NVL(:NEW.IDPRODBASEPRTP, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDPRODBASEPRTP, '') <> NVL(:NEW.IDPRODBASEPRTP, '')) THEN
               V_DESC := V_DESC || ' PrBase=' || :OLD.IDPRODBASEPRTP || '|' || :NEW.IDPRODBASEPRTP;
            END IF;
         ELSE
            V_DESC := V_DESC || ' PrBase=' || :NEW.IDPRODBASEPRTP;
         END IF;
      END IF;
      IF (NVL(:NEW.VRPEFATNUTPRTP, -1) <> -1) OR (UPDATING AND (NVL(:NEW.VRPEFATNUTPRTP, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.VRPEFATNUTPRTP, -1) <> NVL(:NEW.VRPEFATNUTPRTP, -1)) THEN  
               V_DESC := V_DESC || ' AprovNutr=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATNUTPRTP, 5), '9999999990.00')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATNUTPRTP, 5), '9999999990.00'));
            END IF; 
         ELSE
            V_DESC := V_DESC || ' AprovNutr=' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATNUTPRTP, 5), '9999999990.00'));
         END IF;
      END IF;
      IF (NVL(:NEW.QTCALCNUTRPRTP, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTCALCNUTRPRTP, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTCALCNUTRPRTP, -1) <> NVL(:NEW.QTCALCNUTRPRTP, -1)) THEN
               V_DESC := V_DESC || ' QtNutr=' || TRIM(TO_CHAR(ROUND(:OLD.QTCALCNUTRPRTP, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTCALCNUTRPRTP, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' QtNutr=' || TRIM(TO_CHAR(ROUND(:NEW.QTCALCNUTRPRTP, 5), '9999999990.00000'));
         END IF;
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('RECETPCARD', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR);
         END IF;
      END IF;
   END IF;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('LOG_PLA_RECETPCARD','0.00.000'); END;
/

