/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CFOP                                                     */
/* Tabela : CODFISCOPER                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CFOP'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CFOP
GO

CREATE TRIGGER DTULTATU_CFOP
ON CODFISCOPER
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CODFISCOPER', null, 'NRINCIDCFOP=' + NRINCIDCFOP + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CODFISCOPER
      SET DTULTATUCFOP = GETDATE()
      FROM INSERTED;
   END;
END;
GO

